package simplyconnect.mail.bounce

import simplyconnect.mail.MessageWrapper
import simplyconnect.mail.bounce.config.CategoryConfig
import simplyconnect.mail.bounce.config.CategoryDetails
import simplyconnect.mail.bounce.deliverystatus.DeliveryStatusNotification
import simplyconnect.mail.bounce.deliverystatus.DeliveryStatusParser
import simplyconnect.mail.bounce.deliverystatus.RecipientFields

/**
 * User: david
 * Date: 24/03/13
 * Time: 8:14 PM
 */
class Categoriser {
    List<CategoryDetails> matchers = []
    UnstructuredDsnMatcher unstructuredDsnMatcher
    StructuredDsnMatcher structuredDsnMatcher

    Categoriser(File configFile) {
        initMatchers(configFile)
    }

    void initMatchers(File configFile) {
        List<CategoryDetails> matchers = new CategoryConfig().load(configFile)
        unstructuredDsnMatcher = new UnstructuredDsnMatcher(matchers)
        structuredDsnMatcher = new StructuredDsnMatcher()
    }

    List<CategoryResult> categorise(MessageWrapper message) {
        List<CategoryResult> results = []
        if (message.isMultiPartReport()) {
            if (message.isDeliveryStatusReportType()) {
                results = structuredDsnMatcher.match(message)
            }
        } else {
            results = unstructuredDsnMatcher.match(message)
        }
        return results
    }


}
